using System;
using System.Data.OleDb;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Spire.Xls;
using Spire.Xls.Charts;

namespace Spire.Xls.Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnRun;
		private System.Windows.Forms.Button btnAbout;
        private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnRun = new System.Windows.Forms.Button();
            this.btnAbout = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // btnRun
            // 
            this.btnRun.Location = new System.Drawing.Point(448, 56);
            this.btnRun.Name = "btnRun";
            this.btnRun.Size = new System.Drawing.Size(72, 23);
            this.btnRun.TabIndex = 2;
            this.btnRun.Text = "Run";
            this.btnRun.Click += new System.EventHandler(this.btnRun_Click);
            // 
            // btnAbout
            // 
            this.btnAbout.Location = new System.Drawing.Point(528, 56);
            this.btnAbout.Name = "btnAbout";
            this.btnAbout.Size = new System.Drawing.Size(75, 23);
            this.btnAbout.TabIndex = 3;
            this.btnAbout.Text = "Close";
            this.btnAbout.Click += new System.EventHandler(this.btnAbout_Click);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.label1.Location = new System.Drawing.Point(16, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(509, 14);
            this.label1.TabIndex = 4;
            this.label1.Text = "The sample demonstrates how to create combination chart in an excel workbook.";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
            this.ClientSize = new System.Drawing.Size(616, 94);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btnAbout);
            this.Controls.Add(this.btnRun);
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Chart sample";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnRun_Click(object sender, System.EventArgs e)
		{

            //Create workbook
            Workbook workbook = new Workbook();

            //Access the first worksheet
            Worksheet sheet = workbook.Worksheets[0];

            CreateChartData(sheet);

            //Adding new chart to the Worksheet 
            Chart chart = sheet.Charts.Add();
            chart.ChartType = ExcelChartType.BarClustered;
            chart.DataRange = sheet.Range["B3:D6"];
            chart.PrimaryCategoryAxis.Title = "Country";
            chart.PrimaryValueAxis.Title = "Sales ";
            chart.ChartTitle = "Unit sales by country";
            chart.HasDataTable = true;

            //Setting the Serie Names
            ChartSerie one = chart.Series[0];
            one.Name = "Jun";
            ChartSerie serie = chart.Series[1];
            serie.Name = "Aug";

            //setting line serie type
            serie.SerieType = ExcelChartType.Line;
            ChartSerie chartSerie = chart.Series[2];
            chartSerie.Name = "Sep";

            chart.LeftColumn = 1;
            chart.TopRow = 6;
            chart.RightColumn = 11;
            chart.BottomRow = 29;


            //Saving the workbook
            workbook.SaveToFile("Sample.xls");

            ExcelDocViewer(workbook.FileName);

        }

        private void CreateChartData(Worksheet sheet)
        {
            sheet.Name = "Combination Chart";


            //Filling the Data for the chart
            sheet.Range["A1"].Text = "Unit sales by country";
            sheet.Range["A1:D1"].Merge();
            sheet.Range["A1"].Style.Font.IsBold = true;

            sheet.Range["B2"].Text = "Jun";
            sheet.Range["C2"].Text = "Aug";
            sheet.Range["D2"].Text = "Sep";

            sheet.Range["A3"].Text = "Cuba";
            sheet.Range["A4"].Text = "Mexico";
            sheet.Range["A5"].Text = "France";
            sheet.Range["A6"].Text = "German";

            sheet.Range["B3"].NumberValue = 43.55;
            sheet.Range["B4"].NumberValue = 62.35;
            sheet.Range["B5"].NumberValue = 49.79;
            sheet.Range["B6"].NumberValue = 86.45;

            sheet.Range["C3"].NumberValue = 89.29;
            sheet.Range["C4"].NumberValue = 56.42;
            sheet.Range["C5"].NumberValue = 20.08;
            sheet.Range["C6"].NumberValue = 71.23;

            sheet.Range["D3"].NumberValue = 19.56;
            sheet.Range["D4"].NumberValue = 44.27;
            sheet.Range["D5"].NumberValue = 15.78;
            sheet.Range["D6"].NumberValue = 44.61;
        }

        private void ExcelDocViewer(string fileName)
        {
            try
            {
                System.Diagnostics.Process.Start(fileName);
            }
            catch { }
        }

		private void btnAbout_Click(object sender, System.EventArgs e)
		{
			Close();
		}


	}
}
